#!/usr/local/bin/perl
##############################################################################
# Hyperseek Search Engine                                                    #
# Copyright 1997 John Cokos     jcokos@ccs.net                               #
# Created 05/01/1997            Last Modified 05/16/1997                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1997 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Hyperseek Search Engine, including all files in the this distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################



##################################################################
###  ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------###
##################################################################


require ("iweb.pm");
require ("hyperseek.pm");

$PROGRAM="Hyperseek Search Engine URL Addition";
$VERSION="4.01";

# If the admin has decided to restrict the IP
# address that can access this file ...
if ($yh_domains ne "") { if( &Invalid_IP($yh_domains) ) { print "Location: $yh_noip\n\n"; } }

&parse_form;

  #### File names / etc sent from html
  $engine_temp = "$data_dir/hyperseek.temp";

  $category_main = "$data_dir/categories.dat";
  $sub_category_data = "$data_dir/subcategories.dat";
  
  #### Variable names and values sent from html
  $do_spellcheck = $input{'do_spellcheck'};
  $contact_name = $input{'a_name'};
  $contact_email = $input{'a_email'};
  $new_url = $input{'a_url'};
  $new_title = $input{'a_title'};
  $new_text = $input{'a_text'};
  $new_xtra = " " . $input{'a_xtra'} . " ";
  $category = $input{'category'};
  $sub_category = $input{'sub_category'};
  $Qualifier = $input{'Qualifier'};

      
  $action = $input{'action'};
  if ($action eq "New" ) { &new_window; }
  if ($action eq "post_new") { &PostNew; }
  if ($action eq "") { &ERROR("Program Called Incorrectly"); } 




##############################################################################
### Display and process New Message Window
##############################################################################
sub new_window {   

       &ReadCategories;
       print "Content-Type: text/html\n\n";
       print "<HTML><HEAD><TITLE>Add URL</TITLE></HEAD>\n";
       print " <BODY BGCOLOR=\"$pg_color\" TEXT=\"$text_color\">\n";

       print "<CENTER>\n";
       print "<form NAME=\"rply_form\" METHOD=\"POST\" ACTION=\"$CGI_DIR/add_url.cgi\" ENCTYPE=\"x-www-form-urlencoded\">\n";

       print "<table BORDER=\"2\" CELLSPACING=\"0\" CELLPADDING=\"0\">\n";
       print "   <tr bgcolor=\"$title_color\">\n";
       print "     <td HEIGHT=\"24\"><font size=+1 color=\"$ttxt_color\">Add a link to the database...</font></td></tr>\n";
       print "   <tr bgcolor=\"$win_color\">\n";
       print "     <td>\n";

       &CategorySelectList;

       if ($yh_suggest eq "YES") {

          print "    Suggest Category: <input NAME=\"suggestion\" TYPE=\"text\" SIZE=\"30\"><BR>\n";
          print "    (Only enter here if there are no categories that \"fit\" your site, please.)<BR><BR>\n";

       }

       if ($yh_qualify eq "Yes") {

          print "Refine your listing: ";
          &Qualifiers;

       }

       print "<BR><HR><BR>\n";


       print "       <font COLOR=\"$text_color\"><PRE><b>\n";
       print "    Email:         <input NAME=\"a_email\" TYPE=\"text\" SIZE=\"30\">\n";
       print "    Page Title:    <input NAME=\"a_title\" TYPE=\"text\" SIZE=\"30\" MAXLENGTH=\"40\">\n";
       print "    URL:           <input NAME=\"a_url\" TYPE=\"text\" SIZE=\"30\" MAXLENGTH=\"100\" VALUE=\"http://\">\n";
       print "       (You HAVE to use 'http://...' or your link will NOT work)\n\n";


       print "    Description....\n";
       print "                   <textarea NAME=\"a_text\" WRAP=\"virtual\" ROWS=\"3\" COLS=\"30\"></textarea>    \n";
       print "\n";
       print "    Search Words(s)</b>\n";
       print "                   <textarea NAME=\"a_xtra\" WRAP=\"virtual\" ROWS=\"3\" COLS=\"30\"></textarea>    \n";
       print "  For BEST results, enter in unique keywords \n";
       print "  (duplicates do not help you, and separate them with SPACES \n";
       print "  not commas!  Do not use any 'returns' if you can help it.  We \n";
       print "  ask that you limit this to 10-15 keywords (nobody likes to be \n";
       print "  spammed).  Searches are usually CASE InSeniTive (Unless the \n";
       print "  visitor is looking for something real specific, so you don't \n";
       print "  need to enter 'Fred FRED fred'  etc..\n</pre>";
       print "  <center><input type=\"checkbox\" name=\"do_spellcheck\">Check the spelling of your entry?<BR><BR>\n";
       print "         <center><input NAME=\"b_post\" TYPE=\"submit\" VALUE=\"Submit URL\">\n";
       print "         <input NAME=\"action\" TYPE=\"hidden\" VALUE=\"post_new\"></CENTER></BR>\n";
       print "         <input NAME=\"category\" TYPE=\"hidden\" VALUE=\"$category\">\n";
       print "         <input NAME=\"sub_category\" TYPE=\"hidden\" VALUE=\"$sub_category\">\n";
       print "</td></tr>\n";
       print "</table>\n";
       print "</form></center>\n";


	   
  exit 0;

}




##############################################################################
# Get form input and post new message 
##############################################################################
sub PostNew {

        ## Check to see if category is populated
        if ($yh_no_cat ne "") { 
            if( !($input{'category'}) ) { 
                print "Location: $yh_no_cat\n\n";
                exit 0;
            }
        }


        ## Eliminate SPAM...
        if ($yh_bad_words ne "") { 
           ## Get bad words
           if ( &Bad_Words_Present($new_text, "$data_dir/badwords.txt") ) {
              print "Location: $yh_bad_words\n\n";
              exit 0;
           }
        }

        $time = time;

        if($input{'suggestion'}) { 
           $category = "DEFAULT"; 
           $sub_category = $input{'suggestion'}; 
        }


        ## Validate Entries...

           $HTTP = "http://";
           $check_url = $new_url;
           $check_url =~ s/$HTTP//g;
           $check_url =~ s/\///g;
           # The URL is a bit tricky, we need the http:// to validate it, but need to remove
           # the http:// to run it through the alpha screen, hence, we made a second variable...
           if( &Not_Valid_URL($new_url) ) { 
               &ERROR("Invalid URL (<B><I>$new_url</I></B>) Entered<BR><BR>...check to make sure you have the &quot;http://&quot; in the URL"); 
               exit 0;
           }

           if( &Not_Alpha($check_url)) { 
               &ERROR("Non Alphanumeric Characters Found in the URL... Please Re-Enter."); 
               exit 0;
           }
   
           if( &Not_Valid_Email($contact_email) ) { 
               &ERROR("Invalid Email Address (<B><I>$contact_email</I></B>) Entered"); 
               exit 0;
           }

           if( &Not_Alpha($new_title)) { 
               &ERROR("Non Alphanumeric Characters Found in the Title... Please Re-Enter."); 
               exit 0;
           }

           ## We need to remove HTML From the description and check it for other non-numerics.
           $new_text = &Remove_HTML_Tags($new_text);
           if( &Not_Alpha($new_text)) { 
               &ERROR("Non Alphanumeric Characters Found in the Description...<BR>($new_text) <BR> Please Re-Enter."); 
               exit 0;
           }

           ## Check Spelling
           if($do_spellcheck) {
              if ( &Spelling_Errors($new_text, "$data_dir/dictionary") ) { 
                &ERROR($Spelling_Error_Message); 
                exit 0;
              }
           }
   


           ## For the keywords, we always need to remove the commas.  
           ## After that, we check for other non alphas otherwise it'd fail every time.
           $new_xtra =~ s/, / /g;
           $new_xtra =~ s/,/ /g;
           if( &Not_Alpha($new_xtra)) { 
               &ERROR("Non Alphanumeric Characters Found in the Keywords... Please Re-Enter."); 
               exit 0;
           }

        $iCAT = $input{'categeory'};
        @CATS = split(/\|/,$iCAT);
        $category = $CATS[0];
        $sub_category = $CATS[1];

	open (MSG,">>$engine_temp");
	  print MSG "$time|";
	  print MSG "$category|";
          print MSG "$sub_category|";
          print MSG "$Default_Rank|";
          print MSG "$Qualifier|";
          print MSG "$contact_email|";
          print MSG "$new_title|";
          print MSG "$new_url|";
           $new_text =~ s/\r\n/<BR>/g;
          print MSG "$new_text|";
           $new_xtra =~ s/\r\n/ /g;
          print MSG "$new_xtra|1|2|3|4|\n";
	close(MSG);

	print "Location: $yh_thanks\n\n";   

        exit 0;

}





##############################################################################
### Read categories file (admin mode)
##############################################################################
sub CategorySelectList { 


       print "Category:  <SELECT NAME=\"category\">\n";

       for $y (0 .. $#sub_categories ) {
             print "<OPTION VALUE=\"$sub_categories[$y]{'Category'}|$sub_categories[$y]{'SubCategory'}\">$sub_categories[$y]{'Category'} ... $sub_categories[$y]{'SubCategory'}\n";
       }
           
       print "</SELECT><BR>\n";


}
