#!/usr/local/bin/perl
##############################################################################
# Bannermaster CGI Functions for inclusion in programs (Not called direct)   #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The YooHoo Engine, which includes all files in the origninal distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
#
#  PROGRAM: Banner Library
#  Version: 1.20
# __________________________________________________________________________ #


##############################################################################
#  Show a banner for a specific group  (SSI)
##############################################################################
sub Group_Banner {

   local($group) = @_[0];


   if (-e "$data_dir/groups/$group.grp") {

        open ("GRP", "$data_dir/groups/$group.grp");
            @grp_accounts = <GRP>;
        close(GRP);

        open ("LST", "$data_dir/groups/$group.last");
            @last = <LST>;
        close(LST);
   }

   else {

        $group = "default";

        open ("GRP", "$data_dir/groups/default.grp");
            @grp_accounts = <GRP>;
        close(GRP);

        open ("LST", "$data_dir/groups/default.last");
            @last = <LST>;
        close(LST);


   }


   ### Get the name of the last banner shown
   $Last_Banner_Shown = $last[0];
   $Last_Banner_Shown =~ s/\n//g;
   $Last_Banner_Shown =~ s/\cM//g;

   ### Go through the group file to find it.
   ### If we are at the end of the group, start over
   ### If not, then show the next one.
   $Num_Groups = $#grp_accounts;
   $Found = "F";
   for $x (0 .. $#grp_accounts) {
      $acct = $grp_accounts[$x];
      $acct =~ s/\n//g;
      $acct =~ s/\cM//g;
      if ($acct eq $Last_Banner_Shown) {
         if ($x >= $Num_Groups) {
            $Next_Banner_To_Show = 0;
            $account = $grp_accounts[$Next_Banner_To_Show];
            $Found = "T";
         }
         else { 
            $Next_Banner_To_Show = $x + 1;
            $account = $grp_accounts[$Next_Banner_To_Show];
            $Found = "T";
         }
      }
   }

   $account =~ s/\n//g;
  
   open ("LAST",">$data_dir/groups/$group.last");
      &lock(LAST);
      print LAST "$grp_accounts[$Next_Banner_To_Show]\n";
   close(LAST); 
   &unlock(LAST);


   ### Update the Account and Get the banner file.
   &Update_Account($account,"grp");

   
   $CODE =  <<DONE;
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0"><TR><TD><CENTER>
<A HREF="$CGI_DIR/click.cgi?account=$ACCOUNT" TARGET="$target"><IMG SRC="$image" BORDER="0" HEIGHT="$banner_height" WIDTH="$banner_width" ALT="$alt_text"></A></TD></TR><TR BGCOLOR="black"><TD><CENTER><FONT FACE="arial" COLOR="white" SIZE="0">$under_text</FONT></TD></TR></TABLE>
DONE

   return($CODE);
}



sub Update_Account {

   $ACCOUNT = @_[0];
   $SOURCE = @_[1];

   if ( $ENV{'HTTP_REFERER'} ) { $REF=$ENV{'HTTP_REFERER'}; }
   else { $REF=$SELF; }

   open ("ACCT", "$data_dir/accounts/$ACCOUNT/$ACCOUNT.dat");
       @lines = <ACCT>;
   close(ACCT);

   ## Get time for the log file...
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   $month = $mon+1;
   $name = "$month" . "_" . "$mday" . "_" . "$year.log";
   $TIME=time;
   $filename = "$data_dir/accounts/$ACCOUNT/logs/$name";

   open("LOG",">>$filename");
   &lock(LOG);
      print LOG "$TIME|$REF|$SOURCE\n";
   close(LOG);
   &unlock(LOG);

   $tot_file = "$data_dir/accounts/$ACCOUNT/$ACCOUNT.total";
   open("TOT1","$tot_file");
      @entries=<TOT1>;
   close(TOT1);
   $entries[0] =~ s/\n//g;
   @totals = split(/\|/,$entries[0]);
   $impressions = $totals[0];
   $clicks = $totals[1];
   $NewImpressions = $impressions + 1;

   open("TOT",">$tot_file");
   &lock(TOT);
      print TOT "$NewImpressions|$clicks";
   close(TOT);
   &unlock(TOT);
 
   $lines[0] =~ s/\n//g;

   ($acct_name,$acct_login,$acct_password,$target,$redirect_url,$alt_text,$under_text,$banner,$banner_width,$banner_height,$expiration_type,$num_clicks,$num_impressions,$start_date,$end_date) = split(/\|/,$lines[0]);

   
   $RAND = time;

   if ($banner =~ "http") {
        $image = "$banner";
        $image =~ s/\&RAND/\&xfactor=$RAND/g;
 
   }
   else { 
        $image = "$banner_dir/$banner";
        $real_image = "$full_banner_dir/$banner"; 
        $real_image =~ s/\&RAND/\&xfactor=$RAND/g;
   }

}


1;
