#!/usr/local/bin/perl
##############################################################################
# Hyperseek Search Engine                                                    #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Hyperseek Search Engine, including all files in the this distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
###  ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------            ###
##############################################################################

# ======================================================== #
#                                                          #
#  This program (verify-links.cgi) is designed to be run   #
#  from a command line, or via cron.  It will simply take  #
#  too long to run from a browser, even as an nph program  #
#  Depending on the number of links in your Hyperseek DB,     #
#  This could take several hours to complete.              #
#                                                          #
#  You should talk to your ISP or Server Administrator     #
#  before attempting to run this program.                  #
#                                                          #
#  It requires the LWP and FTP Packages (avail at CPAN)    #
#  for Perl Version 5.003+ to be installed and properly    #
#  configured in order to operate properly.                #
#                                                          #
# ======================================================== #


$PROGRAM="Hyperseek Link Verification";
$VERSION="6.01";


use LWP::UserAgent;
require ("iweb.pm");


&main;

exit 0;

sub main {

    # Flush...
    $| = 1;

    $time = localtime;


    open (FILE, ">verify_report.html");

    print FILE "<CENTER><H1>Checking Links . . .</H1></CENTER></HR>";
    print FILE "<PRE>\n";
    print FILE "\n\n---------------Started at $time.----------------\n";
    print FILE "Checking $#lines+1 links. Please be patient.\n";
    print FILE "Started Checking ", $#lines+1, " links at $time, $date.\n";


    $delimiter = '|';
    open(ALLFILE,"$data_dir/hyperseek.dat") || &Fatal;
    foreach $LINE (<ALLFILE>) {
	($ID,$Category,$SubCategory,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);
        
         if ($URL !~ /^http/) { next; }

         &check_link ($ID,$URL);

    }

    $time = localtime;

    print FILE "\n\n---------------Finished at $time.----------------\n";
}


sub check_link {

    my ($key, $url) = @_;

    my ($ua) = new LWP::UserAgent;
    $ua->agent("Links Manager 1.1 : http://www.gossamer-threads.com/scripts/links/"); # Please do not change.
	
	my ($req) = new HTTP::Request ('HEAD', $url);
   	my ($res) = $ua->request($req);
	$code = $res->code;

        ## Uncomment if you want the report to show all URLs that it checked.
	## print FILE "Checking key: $key ($url). . .";		

	if ($res->is_success) {
                ## Uncomment if you want the report to show all URLs that it checked.
                ## print FILE "Success ($code).\n";
	}
	else {
                print FILE "Failure for <a href=\"$url\" target=\"new\">$url</a> ($code)... Options: ";
                print FILE "<a href=\"$CGI_DIR/hs_admin.cgi?action=Delete+This+Entry&id=$key\" target=\"new\">Delete</a> ... ";
                print FILE "<a href=\"$CGI_DIR/hs_admin.cgi?action=Edit&id=$key\" target=\"new\">Edit</a>.\n";
	}
}
